︠12b80d00-1c68-47d2-be87-a804f183847e︠
def prob_succ(k,n):

    B = tuples([-1,1],k)
    U = tuples( (range(1, (n-1)/2 + 1) ) , k)

    def dotprod(b,u):
        sum = 0
        for i in range(len(b)):
            sum = sum + b[i]*u[i]
        return mod(sum, 2*n)

    def sqrt_sums(u):
        
        C = [0 for i in range(2*n)]
        for b in B:
            C[dotprod(b,u)] = C[dotprod(b,u)] + 1
        
        sum1 = 0
        for z in range(2*n):
            sum1 = sum1 + sqrt(C[z])
            
        sum2 = 0
        for z in range(n):
            sum2 = sum2 + sqrt(C[z*2]) - sqrt(C[z*2 + 1])
        
        return sum1*sum1 + sum2*sum2  

    sum = 0
    for u in U:
        sum = sum + sqrt_sums(u)
    
    return sum / (2 * n * (n-1)^k)
︡56a139d4-2c58-479a-b1fb-b3daa5d7d282︡︡
︠4d732e7a-91e4-483c-9d9d-7d703b6c41d0︠
n = 3
r = [(k,prob_succ(k,n)) for k in range(10)]
list_plot(r)
︡67123698-3f47-4197-8e77-86be069618fb︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
